import java.util.ArrayList;
import java.util.Optional;
import java.util.function.Consumer;

public class IntegerArrayStack extends ArrayList implements IntegerStack{

    public int pop() {
        if (isEmpty()){
            throw new EmptyIntegerStackException("Liste vide, impossible de pop");
        }

        int tmp = (int) this.get(0);

        for (int i=0;i<this.size()-1;i++){
            this.set(i, this.get(i + 1));
        }
        this.remove(this.size()-1);
        return tmp;
    }



    public Optional<Integer> popOption() {
        if (isEmpty()){
            return Optional.empty();
        }
        int val = this.pop();
        return Optional.of(val);
    }

    public void ifHeadIsPresent(Consumer<Integer> consumer) {
        if (!isEmpty()) {
            consumer.accept(peek());
        } else {
            throw new EmptyIntegerStackException("Liste vide, impossible de pop");
        }
    }
    public void push(int i) {
        this.add(i);
    }

    public int size() {
        int cpt=0;
        for (Object o: this) {
            cpt++;
        }
        return cpt;
    }

    public int peek() {
        if (isEmpty()) {
            throw new EmptyIntegerStackException("Liste vide, impossible de peek");
        }
        return (int)this.get(0);
    }

    public Optional<Integer> peekOption() {
        return Optional.empty();
    }

    public boolean isEmpty() {
        return this.size() == 0;
    }


    public static void main(String[] args) {
        IntegerStack stack = new IntegerArrayStack();
        stack.push(1);
        stack.push(2);
        stack.push(3);
        System.out.println(stack.pop());
        System.out.println(stack.pop());
        System.out.println(stack.pop());
        stack.ifHeadIsPresent(v -> {
            System.out.println("Head: " + v);
        });
    }
}
