import java.util.Random;

public interface Status {
    static Status process() {
        int chance = new Random().nextInt(3);
        if (chance == 0) {
            return new On();
        } else {
            return chance == 1 ? new Off() : new Err("Oups");
        }
    }

    static Err makeError(String message) {
        return new Err(message);
    }

    default boolean isOn() {
        return false;
    }

    default boolean isOff() {
        return false;
    }

    default String getErrorMessage() {
        throw new UnsupportedOperationException("...");
    }

    // Classe interne statique On
    class On implements Status {
        public boolean isOn() {
            return true;
        }
    }

    // Classe interne statique Off
    class Off implements Status {
        public boolean isOff() {
            return true;
        }
    }

    // Classe interne statique Err
    class Err implements Status {
        private String msg;

        public Err(String msg) {
            this.msg = msg;
        }

        public String getErrorMessage() {
            return this.msg;
        }
    }

    // Classe principale StatusApp
    public class StatusApp {
        public static void main(String[] args) {
            Status s1 = Status.process();
            if (s1.isOn()) {
                System.out.println("L'appareil fonctionne");
            } else if (s1.isOff()) {
                System.out.println("L'appareil est éteint");
            } else
                System.out.println("L'appareil est instable" + s1.getErrorMessage());

            Status s2 = Status.makeError("Oops");
        }
    }
}
