import java.util.Objects;


enum COULEUR {COEUR, CARREAU, PIQUE, TREFLE, ATOUT, JOKER};

public class Carte{
    // Variables de classe

    static public final String[] NOMS_COULEURS = {"\u2665", "\u2666", "\u2660", "\u2663", "AT"};

    static public final String[] NOMS_RANGS = {"Joker", "As", "2", "3", "4",
                     "5", "6", "7", "8", "9", "10", "Valet", "Dame", "Roi", "Cavalier" };
    
    static public final String[] NOMS_ATOUTS = {"Excuse","1","2","3","4","5","6","7","8","9","10","11",
                    "12","13","14","15","16","17","18","19","20","21"};
    // Variables d'instance
    private final COULEUR couleur;
    private final int     rang;
    private final int     force;
    
    // Partie méthodes
    public Carte (COULEUR couleur, int rang) {
        this.couleur = couleur;
        this.rang = rang;
        this.force = rang;
    }
    public Carte (COULEUR couleur, int rang, int force) {
        this.couleur = couleur;
        this.rang = rang;
        this.force = force;
    }

    public COULEUR getCouleur () { return this.couleur;}
    public int getRang () { return this.rang; }

    public int getForce () { return this.force; }

    public String getNomCouleur () { 
        String Nom = "";
        Nom = Carte.NOMS_COULEURS[this.couleur.ordinal()];
        return Nom;
    }

    public String getNomRang () { return Carte.NOMS_RANGS[this.rang];}

    public String getNomComplet () { 
        String fullName = getNomRang();
        if (getNomRang() != "Joker" ) fullName += "-" + getNomCouleur();
        return fullName;
    }

}

