import java.util.Objects;

public class JeuDeCarte {
    // Variables de classe

    private final int STANDARD32 = 32;
    private final int STANDARD52 = 52;
    private final int STANDARDJOK = 54;
    private final int STANDARDTAROT = 56;
    private final int TAROT = 78;

    // Variables d'instance
    private Carte [] jeu;
    private final int tailleDuJeu; 
   
    // Partie méthodes
    public JeuDeCarte (int nbreDeCarte) {

        jeu = new Carte[nbreDeCarte];
        tailleDuJeu = nbreDeCarte;
        
        for (int i=0 ;i<7 ;i++ ) {
            jeu[i] = new Carte(COULEUR.COEUR,i+7);
            jeu[i+7] = new Carte(COULEUR.TREFLE,i+7);
            jeu[i+14] = new Carte(COULEUR.CARREAU,i+7);
            jeu[i+21] = new Carte(COULEUR.PIQUE,i+7);
        }
        jeu[28] = new Carte(COULEUR.COEUR,1);
        jeu[29] = new Carte(COULEUR.TREFLE,1);
        jeu[30] = new Carte(COULEUR.CARREAU,1);
        jeu[31] = new Carte(COULEUR.PIQUE,1);
   
        if ((nbreDeCarte == STANDARD52 )||(nbreDeCarte == STANDARDJOK)||(nbreDeCarte == STANDARDTAROT)||(nbreDeCarte == TAROT))  {
           
            for (int i=0 ; i<5; i++) {
                // on ajoute les cartes de 2 
              jeu[32+i] = new Carte(COULEUR.COEUR,i+1);
              jeu[37+i] = new Carte(COULEUR.TREFLE,i+1);
              jeu[42+i] = new Carte(COULEUR.CARREAU,i+1);
              jeu[47+i] = new Carte(COULEUR.PIQUE,i+1);
            }
        }

        if (nbreDeCarte == STANDARDJOK ) {
            // on ajoute les joker
            jeu[52] = new Carte(COULEUR.JOKER,0);
            jeu[53] = new Carte(COULEUR.JOKER,0);
        }

        if ((nbreDeCarte == STANDARDTAROT )||(nbreDeCarte == TAROT)) {
            // on ajoute les cavaliers
            jeu[52] = new Carte(COULEUR.COEUR,14);
            jeu[53] = new Carte(COULEUR.TREFLE,14);
            jeu[54] = new Carte(COULEUR.PIQUE,0);
            jeu[55] = new Carte(COULEUR.CARREAU,0);
        }

        if (nbreDeCarte == TAROT) {
            // on ajoute les tarot et l'excuse
            int rang = 0;
            for (int i=56 ; i<78; i++) jeu[i] = new Carte(COULEUR.ATOUT,rang++);
        }
    }

    public void set(Carte [] jeu) {
        this.jeu = jeu;
    }

    public Carte get(int i) {
        return jeu[i];
    }

    public int getNbreDeCarte() {
        return tailleDuJeu;
    }

    public JeuDeCarte shuffle() {
        // J'echange 2 cartes dans le tableau et je repète cela 500 fois ...
        Carte [] jeuMelange = this.jeu;
        for (int i=0 ; i<500; i++) {
            int n = (int)(Math.random()* tailleDuJeu);
            int m = (int)(Math.random()* tailleDuJeu);
            Carte temp = jeuMelange[n];
            jeuMelange[n] = jeuMelange[m];
            jeuMelange[m] = temp;
        }
        JeuDeCarte jeuDeCarteMelange = new JeuDeCarte(tailleDuJeu);
        jeuDeCarteMelange.set(jeuMelange); 
        return jeuDeCarteMelange;
    }
}

