# poo2023


# Programmation orientée objet 2023

- D'après le cours de Joël Cavat

Prof. Stéphane Malandain et prof. Yassin Rekik

## Organisation technique

- Etape 1 : liker le _repo_
- Etape 2 : cloner le _repo_:
```
ssh://git@ssh.hesge.ch:10572/stephane.malandai/poo2023.git
```
- Mise à jour du _repo_:
```
git pull
```
URL du premier TP à forker : A venir ... 

## Ressources

- Installez openjdk (LTS) sur vos machines personnelles
- Vérifiez que vous avez le `jshell` d'installé
- [Javadoc d'Oracle](https://docs.oracle.com/en/java/javase/11/docs/api/index.html)
- [Maven in 5 minutes](https://maven.apache.org/guides/getting-started/maven-in-five-minutes.html)
- Bonne documentation sur git : [git-scm : les bases](https://git-scm.com/book/fr/v1/Les-bases-de-Git-Enregistrer-des-modifications-dans-le-d%C3%A9p%C3%B4t)
- [Conventions de nommage Java](https://www.oracle.com/technetwork/java/codeconventions-135099.html)

Pour ceux qui utilisent [Docker](https://docs.docker.com/), une image contenant tous ces outils est disponible ici : https://hub.docker.com/r/hepia/ubuntu-java

## Organisation administrative

### Extrait du règlement

- La participation aux activités pédagogiques est obligatoire
- Le plagiat est considéré comme une faute grave et peut entrainer à une exmatriculation
- L’étudiante ou l’étudiant qui invoque un cas de force majeure pour justifier son absence à un contrôle continu ou à une évaluation doit présenter une requête écrite, accompagnée de pièces justificatives, à la direction d’hepia dans les trois jours ouvrables [...]. 
  - Vos justifications doivent être envoyée à M. Ody Jean-Eudes.
  - Précisez qu'il doit nous transmettre l'acceptation ou le refus par email.
  - Informez nous juste de votre absence. La cause est à justifier auprès du bureau de la gestion académique


### Vos obligations

- Tous les exercices permettent d'atteindre les objectifs du cours
- les exercices seront partiellement corrigés en classe. Ils ne sont pas notés. 
- Le projet est obligatoire et noté. Toutes les étapes sont à rendre aux dates annoncés.

### Disponibilités des assistants/enseignants

- Stéphane Malandain (enseignant principal cours du jour) 
  - Vous pouvez me contacter par email pour prendre rendez-vous ou pour des questions administratives ou d'ordre général
  - Vos questions **techniques et théoriques seront ignorées** -> venez au cours,
    - Je réponds toutefois à vos questions à mon bureau en **B506** le **vendredi de 10h à 12h**
- Yassin Rekik (enseignant principal cours du soir) 
    - Vous pouvez me contacter par email pour prendre rendez-vous ou pour des questions administratives ou d'ordre général
    - Vos questions **techniques et théoriques seront ignorées** -> venez au cours,
    - Je réponds toutefois à vos questions à mon bureau en **A401** le **lundi de 17h à 18h30**
-  Quentin Leblanc répond à vos questions à son bureau **A403** les: 
    - à définir
-  Francisco Mendonça répond à vos questions à son bureau **A403** les: 
    - à définir


## Evaluation
- 3 tests écrits qui donnent une note **N1**
- 4 etapes d'un projet qui donnent une note **N2**
- Test machine qui donne une note **N3**
- Pondération pour note finale : **40 % N1, 30% N2, 30% N3**              
 
## Programme

### Semaine 1 (Lundi 18.09 - Vendredi 22.09)

- Théorie chapitre 1 : les bases de Java (début)
- Présentation IDE - Git - Maven
- Exercices série 1

### Semaine 2 (Lu 25.09 - Ve 29.09)

- Théorie chapitre 1 : les bases de Java (fin)
- Quiz chapitre 1
- Corrections exercices

### Semaine 3 (Lu 02.10 - Ve 06.10)

- Théorie chapitre 2 : classes et objets (début)
- Exercices série 2
- Présentation Projet

### Semaine 4 (Lu 09.10 - Ve 13.10)

- Théorie chapitre 2 : Classes et Objets (fin)
- Corrections exercice série 2
- Projet
- Exercices série 2

### Semaine 5 (Lu 16.10 - Ve 20.10)

- Théorie chapitre 3 : Héritage
- Correction exercices série 2
- Exercices série 3
- **Test 1** (env. 30 minutes)
  
### Semaine sans cours (Lu 23.10 - Ve 27.10)

### Semaine 6 (Lu 30.10 - Ve 03.11)

- Correction test 1
- Théorie chapitre 4 : Le Polymorphisme
- Exercices série 3  
- Etape 1 du projet à rendre le 03/11

### Semaine 7 (Ma 08.11 - Ve 11.11)

- Correction exercices série 3
- Théorie chapitre 5 : Les collections
- Exercices série 5  
- Projet

### Semaine 8 (Lu 13.11 - Ve 17.11)

- **Test 2** (env. 30 minutes)
- Champs : tous ce que l'on a vu jusqu'au polymorphisme 
- Formulaire a4 recto autorisé (manuscrit ou imprimé)
- Exercices série 5

### Semaine 9 (Lu 20.11 - Ve 24.11)

- Théorie chapitre 6 : Les types imbriqués
- Théorie chapitre 7 : Les exceptions
- Correction exercices série 5

### Semaine 10 (Lu 27.11 - Ve 01.12)

- Théorie chapitre 8 : Les classes génériques
- Correction test 2
- Exercices série 6_7_8


### Semaine 11 (Lu 04.12 - Ve 08.12)

- Chapitre pratique 1 : Les tests unitaires
- Fin etape 2 - Projet
- Etudiant du JOUR : Etape 2 du projet à rendre 10.12 


### Semaine 12 (Ma 11.12 - Ve 15.12)

- Théorie chapitre pratique 2 : Java FX / Programmation évènementielle
- Etudiant du SOIR : Etape 2 du projet à rendre 11.12 
- Enoncé étape 3

### Semaine 13 (Lu 18.12 - Ve 22.12)

- Théorie chapitre 9 : programmation fonctionnelle
- Théorie chapitre 10 : Les Streams
- exercices séries 9 et 10
- Correction exercices série 6-7-8

### Semaine sans cours (Lu 25.12 - Ve 29.12) 

### Semaine sans cours (Lu 01.01 - Ve 05.01) 

### Semaine 14 (Lu 08.01 - Ve 12.01)  

- Petit complément de cours : la serialisation
- video : http://gofile.me/6Zy9q/qZoRJaVtY
- Correction exercices series 9 et 10

### Semaine 15 (Lu 15.01 - Ve 19.01)

- **Test 3**
- env. 60 minutes
- Champs : tout ce que l'on a vu depuis le début jusqu'au stream (chap.10 )
- Formulaire a4 recto/verso autorisé (manuscrit ou imprimé)

### Semaine 16 (Lu 22.01 - Ve 26.01)

- 26.01 JOUR : Examen final sur machine Nexus (180 mn) 
- Tout ce que vous avez besoin (enoncé exos, corrigés, doc Java) sera sur la machine
- Editeur : Visual studio code
- Formulaire a4 recto/verso autorisé (manuscrit ou imprimé)
- Stylo + papier brouillon
- Etape 3 du projet à rendre pour le 02.02

### Semaine 17 (Lu 29.01 - Ve 02.02)

- 29.01 SOIR : Examen final sur machine Nexus (180 mn) 
- Tout ce que vous avez besoin (enoncé exos, corrigés, doc Java) sera sur la machine
- Editeur : Visual studio code
- Formulaire a4 recto/verso autorisé (manuscrit ou imprimé)
- Stylo + papier brouillon
- Etape 3 du projet à rendre pour le 02.02
