import java.util.ArrayList;

// -demande le nombre de joueur
// -solde initial par joueur
// -s’occupe du bon déroulement du jeu: effectuer un tour pour traiter chaque joueur
//finir avec la banque et terminer le tour en calculant les gains/pertes et en mettant à jour les soldes
public class GameManager {
    private ArrayList<Joueur> listPlayers;

    public static void initSolde(ArrayList<Joueur> list){
        for(Joueur player: list){
            if (player instanceof JoueurHumain) {
                System.out.println("How much is your 'solde' ?");
                ((JoueurHumain) player).initPlayerSolde(InputFunc.inputUserDouble());
            }
        }
    }

    //for this phase it's only possible to play with one humain player
    static int nbPlayer(){
        System.out.println("How many player do you want for this game ?");
        System.out.println("For the moment you can only play one player against the computer");
        //int nb=  InputFunc.inputUser();
        return 1;
    }

    public static int checkNbPlayers(){
        int nb = nbPlayer();
        while(nb<1 || nb>7){
            System.out.println("The number of player is maximum 7 and minimum 1");
            nb = nbPlayer();
        }
        return nb;
    }
    
    public void createListPlayer(){
        int n = checkNbPlayers();
        listPlayers = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            JoueurHumain player = new JoueurHumain();
            listPlayers.add(player);
        }
    }


//Une variante serait d'utiliser un type optional
    static Carte askCard(JeuDeCarte jeu, int pos){
        System.out.println("Do you want to add a new card in your hand ?");
        System.out.println("(y/N)?");
        String choice = InputFunc.choiceUser();
        if (choice.equals("y") || choice.equals("Y")){
            System.out.println("The card is: "+ jeu.tab.get(pos));
            return jeu.tab.get(pos);}
        else
            return null;
    }

    // TODO the following tasks:
    // implémenter la double mise
    // améliorer l'interface utilisateur (afficher résultat de chaque manche)

    void gameplay(JoueurHumain j1){
        int cpt=0; // todo le compteur est égal à la prochaine carte du jeu -> parcourir tous les paquets et faire +1
        this.createListPlayer();
        listPlayers.set(0,j1);
        initSolde(listPlayers);
        JoueurCroupier croupier = new JoueurCroupier();
        JoueurHumain.setMiseListPlayer(listPlayers);
        JeuDeCarte deck = new JeuDeCarte();
        deck.tab = JeuDeCarte.createDeck();
        ArrayList<JeuDeCarte> tabMains = JeuDeCarte.createTabHand(listPlayers.size()+1, 2, deck);
        j1.hand = tabMains.get(0); j1.showHand();
        JoueurHumain.doubleMise(j1);
        j1.showBet();
        croupier.hand = tabMains.get(1); croupier.showHand();
        double caseAssurance = 0;
        if(croupier.hand.tab.get(0).getRang()==0){ // if croupier's first card is an ace
            j1.setAssurance();
            if(j1.getAssurance()){
                caseAssurance = j1.mise/2;}
        }
        Carte carteChoisie = askCard(deck,cpt);
        j1.addCardToHand(carteChoisie);
        while(carteChoisie!=null){
            cpt++;
            carteChoisie = askCard(deck,cpt);
            j1.addCardToHand(carteChoisie);
            j1.showHand();
            if (JeuDeCarte.totalHand(j1.hand)==21){ //forbidden to play when total hand is 21
                break;
            }
        }
        while(JeuDeCarte.totalHand(croupier.hand)<17&&JeuDeCarte.totalHand(croupier.hand)<=21){
            if (JeuDeCarte.totalHand(croupier.hand)==21){
                if (croupier.hand.tab.get(0).getForce()==0 && croupier.hand.tab.get(1).getForce()==11){  //if croupier did a BlackJack
                    if(j1.getAssurance()) //if the human player assured his bet
                        j1.setSolde(caseAssurance*2);
                }
                break;
            }
            if (JeuDeCarte.totalHand(croupier.hand) > 21) { //forbidden to play when total hand is 21
                break;
            }
            croupier.addCardToHand(deck.tab.get(cpt++));
            croupier.showHand();
        }
        croupier.payment(listPlayers);//todo résultat d'une partie, paiement et statut des soldes de chaque joueur
        JoueurHumain.clearAssurance(listPlayers);
        JeuDeCarte.clearHand(listPlayers);
        croupier.hand.tab.clear();
    }
}
