import java.util.ArrayList;
import java.util.Random;

public class JeuDeCarte {
    public ArrayList<Carte> tab;

    public static int setForce(int rang){
        int force;
        switch (rang){
            case 11:
                case 12:
                    case 13:
                        force = 10;
                        break;
                        default:
                            force = rang;
                            break;
        }
        return force;
    }

    public static ArrayList<Carte> createDeck(){
        ArrayList<Carte> tab = new ArrayList<>();
        for (Couleur color : Couleur.values()) {
            if(color!=Couleur.none){
                for (int i = 1; i <= 13; i++) {
                    Carte carte = new Carte(color, i, setForce(i));
                    tab.add(carte);
                }
            }
        }
        return tab;
    }

    public static void shuffle(ArrayList<Carte> tab) {
        int n = tab.size();
        Random random = new Random();
        for (int i = n - 1; i > 0; i--) {
            int j = random.nextInt(i + 1);
            Carte temp = tab.get(i);
            tab.set(i,tab.get(j));
            tab.set(j,temp);
        }
    }

    /**
     * @param nbJoueur the number of player
     * @param nbCarte the number of cards per player
     * @param jeu the card game used to create the hands
     * @return a tab of shuffled hands
     */
    public static ArrayList<JeuDeCarte> createTabHand(int nbJoueur, int nbCarte, JeuDeCarte jeu){
        shuffle(jeu.tab);
        int cpt=0;

        ArrayList<JeuDeCarte> tabHand = new ArrayList<>();
        for (int i = 0; i < nbJoueur; i++) { //créer un tableau de mains
            JeuDeCarte deck=new JeuDeCarte();
            deck.tab = new ArrayList<>();
            tabHand.add(deck);
        }
        for (JeuDeCarte mains: tabHand) {
            if (mains.equals(tabHand.get(tabHand.size() - 1))) {  //if it's the last hand distribute only one (croupier's hand)
                nbCarte = 1;
            }
            for (int i = 0; i < nbCarte; i++) {
                mains.tab.add(jeu.tab.get(cpt));
                cpt++; //TODO si nb cpt plus grand que nombre de carte dans la variable jeu
            }
        }
        return tabHand;
    }

    public static int totalHand(JeuDeCarte jeu){
        int total=0;
        for(Carte carte: jeu.tab){
            total += carte.getForce();
        }
        return total;
    }

    public static void clearHand(ArrayList<Joueur> list){
        for (Joueur player: list) {
            if (player instanceof JoueurHumain) { // later on implement with-> || player instanceof JoueurOrdinateur (in phase 3)
                JoueurHumain humanPlayer = (JoueurHumain) player;
                humanPlayer.hand.tab.clear();
            }
        }
    }

    /** @param o the object to compare to the current object
    * @return the method returns a negative value
    if the current object is considered "less than" the object passed as a parameter,
    0 if they are considered equal,
    and a positive value if the current object is considered "greater than" the parameter object
     */
        public int compareTo(Object o){
        JeuDeCarte hand = (JeuDeCarte) o;
        return totalHand(this) - totalHand(hand);
    }



    /**
     * //@param n the number of decks to create
     * @return a tab of shuffled decks
     */
    /*public static JeuDeCarte[] paquet(int n){
JeuDeCarte[] paquet = new JeuDeCarte[n];
Type input;
for (int i = 0; i < n; i++) {
System.out.println("\nDeck n°"+(i+1));
// ui.displayGame();
input = JeuDeCarte.convertIntToType(ui.inputUser());
paquet[i] = createPaquet(input);
paquet[i].shuffle();
}
return paquet;
}*/

    /* public String toString() {
String result="";
if (tab!=null){
for (Carte carte:tab) {
result = carte.toString();
System.out.println(carte);
}
}
return result;
}*/
}