import java.util.ArrayList;
import java.util.Scanner;

public class JoueurHumain implements Joueur {
    double mise;
    JeuDeCarte hand;
    private boolean assurance;
    private boolean doubleMise;
    private double solde;

    private double getSolde() {
        return solde;
    }

    public void setSolde(double solde) {
        this.solde += solde;
    }

    public void setAssurance() {
        System.out.println("Do you want to insure your hand ?");
        System.out.println("y/N");
        String choice = InputFunc.choiceUser();
        assurance = choice.equals("y");

    }

    public boolean getAssurance(){
        return assurance;
    }

    public static void clearAssurance(ArrayList<Joueur> list){
        for (Joueur player: list) {
            JoueurHumain human = (JoueurHumain) player;
            human.assurance = false;
        }
    }

    public void setDoubleMise(){
        System.out.println("Do you want to double your bet ?");
        System.out.println("y/N");
        String choice = InputFunc.choiceUser();
        this.doubleMise = choice.equals("y");
    }

    public boolean getDoubleMise(){
        return doubleMise;
    }

    public static void doubleMise(JoueurHumain j1){
        j1.setDoubleMise();
        if(j1.getDoubleMise()){
            j1.mise *= 2;
        }
    }

    public void showBet(){
        System.out.println("Your bet is currently: " + mise);
    }

    private void checkPositiveOrThrow() {
        if (getSolde() < 0) {
            throw new RuntimeException("Your 'solde' is unfortunately negative =( ...");
        }
    }

    public void initPlayerSolde(double solde) {
        while (solde <= 10) {
            // Exception or not supposed to be in this phase, should be ->throw new RuntimeException("The solde must be a possitive number");
            System.out.println("The solde must be a possitive number and should be minimum 10");
            System.out.println("How much do you want for your 'solde' ?");
            solde = InputFunc.inputUserDouble();
        }
        this.solde = solde;
    }
    public void withdraw(double amountToSoustract) {
        this.checkPositiveOrThrow();
        if (getSolde() - amountToSoustract < 0 ) {
            throw new RuntimeException("withdraw unpossible");
        }
        setSolde(getSolde() - amountToSoustract);
    }

    public double setMise() {
        Scanner sc = new Scanner(System.in);
        while (true) {
            System.out.println("How much do you wanna bet ?");
            if (sc.hasNextDouble()) {
                double montantMise = sc.nextDouble();
                if (montantMise >= 10 && montantMise <= getSolde()) {
                    this.mise += montantMise;
                    withdraw(montantMise);  // Substract the bet from the solde
                    break;
                } else {
                    if (montantMise < 10) {
                        System.out.println("The minimum bet is 10€...");
                    } else {
                        System.out.println("Bet amount exceeds the current balance. Please enter an amount less than or equal to your balance.");
                    }
                }
            } else {
                System.out.println("Please enter a valid amount.");
                sc.next();
            }
        }

        return this.mise;
    }

    //not useful for this phase of the project. To be use in the phase 3
    public static void setHandListPlayer(ArrayList<Joueur> list, ArrayList<JeuDeCarte> tabMains){
        int i = 0;
        for(Joueur player: list){
            if (player instanceof JoueurHumain)
                    ((JoueurHumain) player).hand = tabMains.get(i);
            if (player instanceof JoueurSimple)
                    ((JoueurSimple) player).hand = tabMains.get(i);
            if (player instanceof JoueurOrdinateur)
                    ((JoueurOrdinateur) player).hand = tabMains.get(i);
            i++;
        }
    }

    public void addCardToHand(Carte carte) {
        if (carte != null)
            this.hand.tab.add(carte);
    }

    public static void setMiseListPlayer(ArrayList<Joueur> list){
        for(Joueur player: list){
            if (player instanceof JoueurHumain) {
                JoueurHumain humainPlayer = (JoueurHumain) player;
                humainPlayer.setMise();
            }
        }
    }
    public void showHand() {
        System.out.println("Your hand is: ");
        for (Carte carte:hand.tab) {
            System.out.println(carte);
        }
        System.out.println("Total force: " + JeuDeCarte.totalHand(hand));
    }
}
