import java.util.HashMap;
import java.nio.file.*;
import java.util.Scanner;
import java.io.IOException;
import java.util.ArrayList;
public class JoueurOrdinateur implements Joueur{

    double mise;
    JeuDeCarte hand;
    private double solde;
    Strat[][] stratTab;
    
    public double setMise() {
        return 0;
    }

    public void addCardToHand(Carte carte) {
        if (carte != null)
            this.hand.tab.add(carte);
    }
    
    public void showHand() {
        System.out.println("IA player's hand is: ");
        for (Carte carte:hand.tab) {
            System.out.println(carte);
        }
        System.out.println("Total force: " + JeuDeCarte.totalHand(hand));
    }


    public void initPlayerSolde(double solde) {
        solde = 50;
        this.solde = solde;
    }

    public void showBet(){
        System.out.println("IA player's bet is currently: " + mise);
    }

    public ArrayList<Strat> fillTabFromCSV(String tabFile){
        ArrayList<Strat> liste1d = new ArrayList<>();
        //String tabFile = "tabStrat.csv";
        try {
            Scanner sc = new Scanner(Paths.get(tabFile));
            while (sc.hasNextLine()) {
                String ligne = sc.nextLine();
                Scanner ligneScanner = new Scanner(ligne);
                ligneScanner.useDelimiter(",");
                while (ligneScanner.hasNext()) {
                    Strat strata = Strat.valueOf(ligneScanner.next());
                    liste1d.add(strata);
                    if (!ligneScanner.hasNext() && sc.hasNextLine()) {
                        ligne = sc.nextLine();
                        ligneScanner = new Scanner(ligne);
                        ligneScanner.useDelimiter(",");
                    }
                }
            }
            sc.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return liste1d;
    }
    
    //tableau 2 dimension pour les décisions basées sur le tab
    public Strat[][] tabStafillStratTab(ArrayList<Strat> tabStrat, int lig, int col){
        /*lig = 25;
col = 10;*/
        if (lig <= 0 || col <= 0) {
            throw new IllegalArgumentException("La taille du tableau doit être supérieure à zéro.");
        }

        if(tabStrat.isEmpty()){
            return null;
        }

        if (lig * col > tabStrat.size()) {
            throw new IllegalArgumentException("Le tableau n'est pas assez grand pour contenir tous les éléments de tabStrat.");
        }


        
        stratTab = new Strat[lig][col];
        int index = 0;
        for (int i = 0; i < lig; i++) {
            for (int j = 0; j < col; j++) {
                stratTab[i][j] = tabStrat.get(index);
                index++;
            }
        }
        return stratTab;
    }

    public HashMap<Integer, Integer> HMBanqueHand(){
        //pour les cartes de la banque -> hashmap avec comme clé les cartes et comme val la dimension y du tab 2D
        HashMap<Integer, Integer> carteBanque = new HashMap<>(); //K = carte, V = val in tab strat
        carteBanque.put(2,0);
        carteBanque.put(3,1);
        carteBanque.put(4,2);
        carteBanque.put(5,3);
        carteBanque.put(6,4);
        carteBanque.put(7,5);
        carteBanque.put(8,6);
        carteBanque.put(9,7);
        carteBanque.put(10,8);
        carteBanque.put(1,9);

        return carteBanque;
    }
    
    public int convertHandToXcoord(JeuDeCarte hand){
        if(hand.tab.isEmpty())
            throw new NullPointerException("Une main ne peut-être vide");
        int val=0;
        int total = JeuDeCarte.totalHand(hand);
        if(hand.tab.size()==2){
            if(hand.containsCarte("As")){
                val = switch (hand.tab.get(0/*todo*/).getRang()) {
                    case 7 -> 12;
                    case 6 -> 13;
                    case 5 -> 14;
                    case 4 -> 15;
                    case 3 -> 16;
                    case 2 -> 17;
                    case 8, 9, 10 -> 11;
                    default -> val;
                };
            }
            if(hand.tab.get(0).getNomRang().equals(hand.tab.get(1).getNomRang())){ //s'il s'agit d'une paire
                val = switch (hand.tab.get(0).getRang()) {
                    case 10 -> 19;
                    case 9 -> 20;
                    case 8 -> 18;
                    case 7 -> 21;
                    case 6 -> 22;
                    case 5 -> 23;
                    case 4 -> 24;
                    case 3, 2 -> 25;
                    default -> val;
                };
            }
        }
        if (total<17){
                for(int i = 8; i <= total; i++) {
                    val++;
                }
            }
        return val;
    }
    public void setSolde(double solde) {
        this.solde += solde;
    }
    public Strat lireTabStrat(Strat[][] tab, JeuDeCarte handIA, Carte carteCroupier){
        int x = convertHandToXcoord(handIA);
        int y = HMBanqueHand().get(carteCroupier.getRang());
        return tab[x][y];
    }
}
