import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;

import static org.junit.jupiter.api.Assertions.*;


class JoueurOrdinateurTest {
    @Test
    @DisplayName("Check valeurs limites pour lig et col")
    void test_StratTab_para(){
        int lig = 0, col = 0, l=-2,c=-3;
        ArrayList<Strat> tab=new ArrayList<>();
        JoueurOrdinateur playerTest = new JoueurOrdinateur();
        assertThrows(IllegalArgumentException.class, ()->{
            playerTest.tabStafillStratTab(tab, lig, col);
        });
        assertThrows(IllegalArgumentException.class, ()->{
            playerTest.tabStafillStratTab(tab, l, c);
        });
    }

    @Test
    @DisplayName("Check si le retour de fonction est null")
    void test_TabStafillStratTabisNull(){
        int l=2,c=3;
        ArrayList<Strat> tab=new ArrayList<>();
        JoueurOrdinateur playerTest = new JoueurOrdinateur();
        assertNull(playerTest.tabStafillStratTab(tab, l, c));
    }

    @Test
    @DisplayName("Test différentes sortes de mains")
    //test différents scénarios de main avec un grand total, un total à zéro, une main avec un total null etc.
    void test_ConvertHandToXCoord(){
        JoueurOrdinateur playerTest = new JoueurOrdinateur();
        JeuDeCarte jeuTest = new JeuDeCarte();
        Carte carteTest = new Carte(Couleur.pique, 6, 6);
        assertThrows(NullPointerException.class, ()->{
            playerTest.convertHandToXcoord(jeuTest);
        });
        jeuTest.tab = new ArrayList<>();
        jeuTest.tab.add(carteTest);
        jeuTest.tab.add(carteTest);
        assertEquals(27,  playerTest.convertHandToXcoord(jeuTest));
        Carte carteTestAs = new Carte(Couleur.pique, 1, 5);
        jeuTest.tab.remove(1);
        jeuTest.tab.add(carteTestAs);
        assertEquals(17,  playerTest.convertHandToXcoord(jeuTest));
    }
}   